
// VMD3110_4PH_MCU_Update_UtilityDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VMD3110_4PH_MCU_Update_Utility.h"
#include "VMD3110_4PH_MCU_Update_UtilityDlg.h"
#include "VMD3110_4PH_MCU_Update.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

CUIntArray ports;

const int PROGRAM_START = 0;
const int OPEN_UART     = 1;
const int OPEN_FILE     = 2;
const int UPDATE_MCU    = 3;
const int CLOSE_UART    = 4;

int g_nStep = 0;


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CVMD3110_4PH_MCU_Update_UtilityDlg dialog




CVMD3110_4PH_MCU_Update_UtilityDlg::CVMD3110_4PH_MCU_Update_UtilityDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVMD3110_4PH_MCU_Update_UtilityDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVMD3110_4PH_MCU_Update_UtilityDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT1, m_CEdit_PathName);
	DDX_Control(pDX, IDC_BUTTON1, m_CButton_OpenFile);
	DDX_Control(pDX, IDC_EDIT2, m_CEdit_Version);
	DDX_Control(pDX, IDC_EDIT3, m_CEdit_DLL_Ver);
	DDX_Control(pDX, IDC_PROGRESS1, m_CProgressCtrl_Erase);
	DDX_Control(pDX, IDC_PROGRESS2, m_CProgressCtrl_Update);
	DDX_Control(pDX, IDC_PROGRESS3, m_CProgressCtrl_Check);
	DDX_Control(pDX, IDC_STATIC_Erase, m_CStatic_Erase);
	DDX_Control(pDX, IDC_STATIC_Update, m_CStatic_Update);
	DDX_Control(pDX, IDC_STATIC_Check, m_CStatic_Check);
	DDX_Control(pDX, IDC_BUTTON2, m_CButton_Update);
	DDX_Control(pDX, IDC_CHECK1, m_CButton_Check);
	DDX_Control(pDX, IDC_COMBO1, m_CComboBox_PortNum);
}

BEGIN_MESSAGE_MAP(CVMD3110_4PH_MCU_Update_UtilityDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON1, &CVMD3110_4PH_MCU_Update_UtilityDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CVMD3110_4PH_MCU_Update_UtilityDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CVMD3110_4PH_MCU_Update_UtilityDlg::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, &CVMD3110_4PH_MCU_Update_UtilityDlg::OnBnClickedButton4)
END_MESSAGE_MAP()


// CVMD3110_4PH_MCU_Update_UtilityDlg message handlers

BOOL CVMD3110_4PH_MCU_Update_UtilityDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	ports.RemoveAll();

	for (UINT i=1; i<256; i++)
	{
		//Form the Raw device name
		CString sPort;
		sPort.Format(_T("COM%d"), i);
		
		COMMCONFIG cc;
		DWORD dwSize = sizeof(COMMCONFIG);
		if (GetDefaultCommConfig(sPort, &cc, &dwSize))
		{
			ports.Add(i);
		}
	}

	int nSize = ports.GetSize();
	if( nSize > 0 )
	{
		m_CComboBox_PortNum.ResetContent();
		for ( int i=0 ; i<nSize ; i++ )
		{
			CString PortString;
			PortString.Format("COM%d", ports.GetAt(i));
			m_CComboBox_PortNum.InsertString(i, PortString);
		}
		m_CComboBox_PortNum.SetCurSel(0);
	}
	else
	{
		ports.RemoveAll();
		m_CComboBox_PortNum.ResetContent();
		for ( int i=0 ; i<9 ; i++ )
		{
			CString PortString;
			PortString.Format("COM%d",i+1);
			m_CComboBox_PortNum.InsertString(i, PortString);
			ports.Add(i+1);
		}
		m_CComboBox_PortNum.SetCurSel(0);
	}

	m_CProgressCtrl_Erase.SetRange(0,100);
	m_CProgressCtrl_Update.SetRange(0,100);
	m_CProgressCtrl_Check.SetRange(0,100);

	m_CButton_Check.SetCheck(BST_UNCHECKED);


	// Open Button
	CWnd *pButton1 = this->GetDlgItem(IDC_BUTTON3);
	pButton1->EnableWindow(TRUE);

	// Close Button
	CWnd *pButton2 = this->GetDlgItem(IDC_BUTTON4);
	pButton2->EnableWindow(FALSE);

	ButtonSetting(CLOSE_UART);


	CString DLLver;
	int nMajorVersion = 0;
	int nMinorVersion = 0;
	VMD_MCU_Update_Get_DLL_Version(&nMajorVersion, &nMinorVersion);
	DLLver.Format(TEXT("DLL ver : %d.%d"), nMajorVersion, nMinorVersion);
	m_CEdit_DLL_Ver.SetWindowText(DLLver);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CVMD3110_4PH_MCU_Update_UtilityDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVMD3110_4PH_MCU_Update_UtilityDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVMD3110_4PH_MCU_Update_UtilityDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CVMD3110_4PH_MCU_Update_UtilityDlg::OnDestroy()
{
	CDialog::OnDestroy();

	VMD_MCU_Update_Disconnect();
	ButtonSetting(CLOSE_UART);
}

void CVMD3110_4PH_MCU_Update_UtilityDlg::OnTimer(UINT_PTR nIDEvent)
{
	if( nIDEvent == 1 )
	{
		KillTimer(1);

		if( g_nStep == 1 )
		{
			m_CProgressCtrl_Erase.SetPos(30);
			m_CStatic_Erase.SetWindowText(TEXT("30%"));

			// 1. EraseFlash
			int nResult1 = VMD_MCU_Update_EnterUpdateModeAndEraseFlash();
			if( nResult1 == 1 )
			{
				m_CProgressCtrl_Erase.SetPos(60);
				m_CStatic_Erase.SetWindowText(TEXT("60%"));
				g_nStep = 2;
				SetTimer(1, 0, NULL);
				CDialog::OnTimer(nIDEvent);
				return;
			}
			else
			{
				MessageBox(TEXT("Enter update mode and erase flash is failed!!!"));
				g_nStep = 0;
				ButtonSetting(OPEN_FILE);
			}
		}

		if( g_nStep == 2 )
		{
			m_CProgressCtrl_Erase.SetPos(80);
			m_CStatic_Erase.SetWindowText(TEXT("80%"));

			// 2. prepare Update
			int nResultUpdate = VMD_MCU_Update_Start();
			if( nResultUpdate == 1 )
			{
				m_CProgressCtrl_Erase.SetPos(100);
				m_CStatic_Erase.SetWindowText(TEXT("100%"));
				g_nStep = 3;
				SetTimer(1, 0, NULL);
				CDialog::OnTimer(nIDEvent);
				return;
			}
			else
			{
				MessageBox(TEXT("Start update error!!!"));
				g_nStep = 0;
				ButtonSetting(OPEN_FILE);
			}
		}

		if( g_nStep == 3 )
		{
			// 3. Update

			int nResult = VMD_MCU_Update_DoUpdate();
			if( nResult == 1 )
			{
				unsigned int nPercent = 0;
				if( VMD_MCU_Update_IsUpdateFinish(&nPercent) == 1 )
				{
					g_nStep = 4;

					int nCheck = m_CButton_Check.GetCheck();
					if( BST_UNCHECKED == nCheck )
						g_nStep = 6;
				}

				CString UpdateProgress;
				UpdateProgress.Format(TEXT("%d%%"), nPercent);
				m_CStatic_Update.SetWindowText(UpdateProgress);

				m_CProgressCtrl_Update.SetPos(nPercent);

				SetTimer(1, 0, NULL);
				CDialog::OnTimer(nIDEvent);
				return;
			}
			else
			{
				MessageBox(TEXT("Update is failed!!!"));
				g_nStep = 0;
				ButtonSetting(OPEN_FILE);
			}
		}

		if( g_nStep == 4 )
		{
			// 4. prepare Check
			int nResultCheck = VMD_MCU_Update_Check_Start();
			if( nResultCheck == 1 )
			{
				g_nStep = 5;
				SetTimer(1, 0, NULL);
				CDialog::OnTimer(nIDEvent);
				return;
			}
			else
			{
				MessageBox(TEXT("Check error!!!"));
				g_nStep = 0;
				ButtonSetting(OPEN_FILE);
			}
		}

		if( g_nStep == 5 )
		{
			// 5. Check
			if( VMD_MCU_Update_DoCheck() == 1 )
			{
				unsigned int nPercent = 0;

				if( VMD_MCU_Update_IsCheckFinish(&nPercent) == 1 )
				{
					g_nStep = 6;
				}

				CString CheckProgress;
				CheckProgress.Format(TEXT("%d%%"), nPercent);
				m_CStatic_Check.SetWindowText(CheckProgress);

				m_CProgressCtrl_Check.SetPos(nPercent);

				SetTimer(1, 0, NULL);
				CDialog::OnTimer(nIDEvent);
				return;
			}
			else
			{
				MessageBox(TEXT("Check error!!!"));
				g_nStep = 0;
				ButtonSetting(OPEN_FILE);
			}
		}

		if( g_nStep == 6 )
		{
			// 6. Final
			int nResult4 = VMD_MCU_Update_Finish();
			if( nResult4 == 1 )
			{
				int nResult5 = VMD_MCU_Update_Reboot();
				if( nResult5 == 1 )
				{
					MessageBox(TEXT("Update finished, VMD3110-4PH will restart after 3 seconds."));
				}
				else
				{
					MessageBox(TEXT("Reboot failed!!!"));
				}
			}
			else
			{
				MessageBox(TEXT("Update error!!!"));
			}

			g_nStep = 0;
			ButtonSetting(OPEN_FILE);
		}
	}

	CDialog::OnTimer(nIDEvent);
}

void CVMD3110_4PH_MCU_Update_UtilityDlg::OnBnClickedButton1()
{
	CFileDialog fileDlg(TRUE, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, TEXT("BIN Files (*.BIN)|*.BIN"));
	if(fileDlg.DoModal() == IDOK)
	{
		CString pathName = fileDlg.GetPathName();

		// Implement opening and reading file in here.
		TCHAR szVersion[11];
		memset(szVersion, 0, sizeof(szVersion));

#ifdef  UNICODE
		int nIsLoad = VMD_MCU_Update_LoadBinFile_W(pathName.GetString(), szVersion, 11);
#else
		int nIsLoad = VMD_MCU_Update_LoadBinFile(pathName.GetString(), szVersion, 11);
#endif
		if( nIsLoad != 1 )
		{
			MessageBox(TEXT("Load bin file is failed!!!"));
			ButtonSetting(OPEN_UART);
			return;
		}

		CString fileName = fileDlg.GetFileTitle();

		m_CEdit_PathName.SetWindowText(pathName);

		if(    szVersion[0] != 'V'
			|| szVersion[1] != 'D'
			|| szVersion[2] != '3'
			|| szVersion[3] != '1'
			|| szVersion[4] != '1')
		{
			MessageBox(TEXT("Warning!!! This is not a correct file!!!"));
			OnCancel();
		}

		m_CEdit_Version.SetWindowText(szVersion);

		ButtonSetting(OPEN_FILE);
	}
}

void CVMD3110_4PH_MCU_Update_UtilityDlg::OnBnClickedButton2()
{
	ButtonSetting(UPDATE_MCU);

	g_nStep = 1;

	m_CProgressCtrl_Erase.SetPos(10);
	m_CStatic_Erase.SetWindowText(TEXT("10%"));

	m_CProgressCtrl_Update.SetPos(0);
	m_CStatic_Update.SetWindowText(TEXT("0%"));

	m_CProgressCtrl_Check.SetPos(0);
	m_CStatic_Check.SetWindowText(TEXT("0%"));

	SetTimer(1, 0, NULL);
}

//const int PROGRAM_START = 0;
//const int OPEN_UART     = 1;
//const int OPEN_FILE     = 2;
//const int UPDATE_MCU    = 3;
//const int CLOSE_UART    = 4;
void CVMD3110_4PH_MCU_Update_UtilityDlg::ButtonSetting(int nButtonState)
{
	switch(nButtonState)
	{
	case PROGRAM_START:
		{
			m_CButton_OpenFile.EnableWindow(FALSE);
			m_CButton_Update.EnableWindow(FALSE);
		}
		break;
	case OPEN_UART:
		{
			m_CButton_OpenFile.EnableWindow(TRUE);
			m_CButton_Update.EnableWindow(FALSE);
		}
		break;
	case OPEN_FILE:
		{
			m_CButton_OpenFile.EnableWindow(TRUE);
			m_CButton_Update.EnableWindow(TRUE);
		}
		break;
	case UPDATE_MCU:
		{
			m_CButton_OpenFile.EnableWindow(FALSE);
			m_CButton_Update.EnableWindow(FALSE);
		}
		break;
	case CLOSE_UART:
		{
			m_CButton_OpenFile.EnableWindow(FALSE);
			m_CButton_Update.EnableWindow(FALSE);
			
			m_CEdit_PathName.SetWindowText(TEXT(""));
			m_CEdit_Version.SetWindowText(TEXT(""));
		}
		break;
	}
}

void CVMD3110_4PH_MCU_Update_UtilityDlg::OnBnClickedButton3()
{
	unsigned int nPortSelect = m_CComboBox_PortNum.GetCurSel();
	unsigned int nPortCount = ports.GetSize();
	if( nPortSelect >= nPortCount )
	{
		MessageBox("Select serial port failed!!!");
		return;
	}

	unsigned int nSerialPortNum = ports.GetAt(nPortSelect);

	int nResult = VMD_MCU_Update_Connect(nSerialPortNum);
	if( nResult == 1 )
	{
		// Open Button
		CWnd *pButton1 = this->GetDlgItem(IDC_BUTTON3);
		pButton1->EnableWindow(FALSE);

		// Close Button
		CWnd *pButton2 = this->GetDlgItem(IDC_BUTTON4);
		pButton2->EnableWindow(TRUE);

		ButtonSetting(OPEN_UART);
	}
	else if( nResult == -11 )
	{
		MessageBox(TEXT("This serial port does not connect to VMD3110-4PH!!!"));
	}
	else
	{
		MessageBox(TEXT("Connect to device failed!!!"));
	}
}

void CVMD3110_4PH_MCU_Update_UtilityDlg::OnBnClickedButton4()
{
	VMD_MCU_Update_Disconnect();

	// Open Button
	CWnd *pButton1 = this->GetDlgItem(IDC_BUTTON3);
	pButton1->EnableWindow(TRUE);

	// Close Button
	CWnd *pButton2 = this->GetDlgItem(IDC_BUTTON4);
	pButton2->EnableWindow(FALSE);

	ButtonSetting(CLOSE_UART);
}
